"use strict";

exports.__esModule = true;
exports.pick = pick;
exports.omit = omit;

/**
 * Copyright (c) Nicolas Gallagher.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 */
function filterObjectProperties(obj, list, pick) {
  var nextObj = {};

  if (obj != null) {
    for (var key in obj) {
      if (obj.hasOwnProperty(key)) {
        if (pick) {
          if (list[key] === true) {
            nextObj[key] = obj[key];
          }
        } else if (list[key] !== true) {
          nextObj[key] = obj[key];
        }
      }
    }
  }

  return nextObj;
}

function pick(obj, list) {
  return filterObjectProperties(obj, list, true);
}

function omit(obj, list) {
  return filterObjectProperties(obj, list, false);
}