"use strict";

exports.__esModule = true;
exports.default = useHover;

var React = _interopRequireWildcard(require("react"));

var _events = require("./events");

exports.useHoverEvents = _events.useHoverEvents;

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var emptyObject = {};
var initialCoordinates = {
  x: null,
  y: null
};

function useHover(targetRef, config) {
  var _ref = config || emptyObject,
      contain = _ref.contain,
      disabled = _ref.disabled,
      updates = _ref.updates;

  var _React$useState = React.useState(false),
      isHovered = _React$useState[0],
      setIsHovered = _React$useState[1];

  var _React$useState2 = React.useState(initialCoordinates),
      coordinates = _React$useState2[0],
      setCoordinates = _React$useState2[1];

  var hoverEventsConfig = React.useMemo(function () {
    function hoverUpdateHandler(e) {
      var x = e.x,
          y = e.y;
      setCoordinates({
        x: x,
        y: y
      });
    }

    return {
      contain: contain,
      disabled: disabled,
      onHoverChange: function onHoverChange(isHovered) {
        setIsHovered(isHovered);

        if (!isHovered && updates === true) {
          setCoordinates(initialCoordinates);
        }
      },
      onHoverUpdate: updates === true ? hoverUpdateHandler : null
    };
  }, [contain, disabled, updates]);
  (0, _events.useHoverEvents)(targetRef, hoverEventsConfig);
  return _objectSpread({
    isHovered: isHovered
  }, coordinates);
}