"use strict";

exports.__esModule = true;
exports.default = usePreferences;

var _useMediaQuery = _interopRequireDefault(require("../__modules__/useMediaQuery"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 */
function usePreferences() {
  var prefersDark = (0, _useMediaQuery.default)('(prefers-color-scheme: dark)');
  var reducedMotion = (0, _useMediaQuery.default)('(prefers-reduced-motion)');
  var colorScheme = prefersDark ? 'dark' : 'light';
  return {
    colorScheme: colorScheme,
    reducedMotion: reducedMotion
  };
}

module.exports = exports.default;